<?PHP

#ini_set('display_errors', E_ERROR); ## LIVE
#error_reporting(E_ERROR); ## LIVE

ini_set('display_errors', 1); ## TESTING
error_reporting(E_ALL);  ## TESTING


header("Content-Type: text/html; charset=utf-8");
mb_internal_encoding('UTF-8');

$filelist = array();
$filelist[] = "assets/css/app.min.css";
$filelist[] = "assets/styles/bright.min.css";
$filelist[] = "templates/install_page1.tmpl";
$filelist[] = "templates/index_install.tmpl";
$filelist[] = "templates/install_page2.tmpl";
$filelist[] = "templates/install_page2_entry.tmpl";
$filelist[] = "sql/default.sql";
$filelist[] = "sql/bootinterface.sql";

foreach($filelist as $filename)
{
	if (!file_exists($filename))
	{
		die("Important file missing! Installation aborted.\n<br>\nWichtige Datei fehlt! Installation abgebrochen.\n<br><br>\nFile / Datei: ".$filename);
	}
}

require_once("include/formularfunctions.php");

function getFirstPage($status = "", $mysqlhost = "", $mysqluser = "", $mysqlpassword = "", $mysqldatabase = "", $adminuser = "", $adminpassword = "", $adminemail = "", $createtables = "no")
{
	$tmpl = implode(" ", file("templates/install_page1.tmpl"));
	$tmpl = str_replace('{status}', ($status == "" ? "" : "<div align=\"center\">".$status."</div>"), $tmpl);
	$tmpl = str_replace('{mysqlhost}', $mysqlhost, $tmpl);
	$tmpl = str_replace('{mysqluser}', $mysqluser, $tmpl);
	$tmpl = str_replace('{mysqlpassword}', $mysqlpassword, $tmpl);
	$tmpl = str_replace('{mysqldatabase}', $mysqldatabase, $tmpl);
	$tmpl = str_replace('{adminuser}', $adminuser, $tmpl);
	$tmpl = str_replace('{adminpassword}', $adminpassword, $tmpl);
	$tmpl = str_replace('{adminemail}', $adminemail, $tmpl);
	$tmpl = str_replace('{createtables}', $createtables, $tmpl);
	$tmpl = str_replace('{fs_webuiadmin}', ($createtables == "no" ? " class=\"hidden\"" : ""), $tmpl);
	$tmpl = str_replace('{img_tick}', ($createtables == "no" ? " style=\"visibility:hidden;\"" : ""), $tmpl);

	$extensions = [];
	$disableNext = false;

	if(extension_loaded('ssh2')) {
		$extensions[] = '<div class="alert alert-success" role="alert">PHP Extension "ssh2" is loaded!</div>';
		$disableNext = false;
	} else {
		$extensions[] = '<div class="alert alert-danger" role="alert">PHP Extension "ssh2" is not loaded! It is required for the connection between the web interface and TeamSpeak Server.</div>';
		$disableNext = true;
	}
	$tmpl = str_replace('{extension_output}', implode('<br>', $extensions), $tmpl);
	$tmpl = str_replace('{btn_disabled}', $disableNext ? 'disabled' : '', $tmpl);

	return $tmpl;
}

function getSQLFiles() {
	$file = file("sql/default.sql", FILE_IGNORE_NEW_LINES+FILE_SKIP_EMPTY_LINES);

	$count = count($file);

	foreach(file("sql/bootinterface.sql", FILE_IGNORE_NEW_LINES+FILE_SKIP_EMPTY_LINES) as $line) {
		$file[] = $line;
	}

	return $file;
}

function getTableName($sqlline) {
	$pos1 = strpos($sqlline, "`");
	$pos2 = strpos($sqlline, "`", $pos1+1);

	return substr($sqlline, $pos1+1, $pos2-($pos1+1));
}

function getTableList($dblink) {
	$queryTableList = mysqli_query($dblink, "SHOW TABLES LIKE 'jts3servermod%'");

	if($queryTableList === false)
		return null;

	if(mysqli_num_rows($queryTableList) == 0)
		return false;

	$table_list = [];
	while($row = mysqli_fetch_row($queryTableList)) {
		$table_list[] = $row[0];
	}

	return $table_list;
}

if(isset($_SERVER['HTTP_X_REQUESTED_WITH']) && !empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
	#var_dump(json_encode($_POST));
	$progress = [];

	if(isset($_POST['step']) && $_POST['step'] == 'mysql') {
		$dblink = @mysqli_connect($_POST['mysqlhost'], $_POST['mysqluser'], $_POST['mysqlpassword'], $_POST['mysqldatabase']);

		if(mysqli_connect_error() != null) {
			die(json_encode(['status' => 'error', 'message' => 'Unable to connect to MySQL server! '.mysqli_connect_error()]));
		} elseif(!mysqli_set_charset($dblink, "utf8")) {
			die(json_encode(['status' => 'error', 'message' => 'Unable to select UTF8 charset for the MySQL connection']));
		} else {
			$fh = fopen("config/dbconnect_config.php", 'w');

			if(!$fh) {
				die(json_encode(['status' => 'error', 'message' => 'Unable to write config file. Please check if PHP can write to config/dbconnect_config.php.']));
			} else {
				fwrite($fh, "<?php /*\n");
				fwrite($fh, $_POST['mysqlhost']."\n");
				fwrite($fh, $_POST['mysqluser']."\n");
				fwrite($fh, $_POST['mysqlpassword']."\n");
				fwrite($fh, $_POST['mysqldatabase']."\n");
				fwrite($fh, "*/ ?>");
				fclose($fh);
				chmod("config/dbconnect_config.php", 0777);

				if($_POST['tables'] === 'no') $step = 'step4';
				else $step = 'step3';

				mysqli_close($dblink);

				die(json_encode(['status' => 'success', 'step' => $step]));
			}
		}
	} elseif(isset($_POST['step']) && $_POST['step'] == 'admin') {
		if($_POST['tables'] == 'yes' && (!isset($_POST['adminuser']) || $_POST['adminuser'] == "" || !isset($_POST['adminpassword']) || $_POST['adminpassword'] == "" || !isset($_POST['adminemail']) || $_POST['adminemail'] == "" || !isset($_POST['adminpassword_confirm']) || $_POST['adminpassword_confirm'] == "")) {
			die(json_encode(['status' => 'error', 'message' => "Don't forget to set a web interface admin username, password and email!"]));
		} elseif($_POST['tables'] == 'yes' && isset($_POST['adminpassword']) && isset($_POST['adminpassword_confirm']) && $_POST['adminpassword'] != $_POST['adminpassword_confirm']) {
			die(json_encode(['status' => 'error', 'message' => "The passwords don't match."]));
		} elseif($_POST['tables'] == 'yes' && isset($_POST['adminpassword']) && isset($_POST['adminpassword_confirm']) && $_POST['adminpassword'] == $_POST['adminpassword_confirm'] && !isPasswordValid($_POST['adminpassword'])) {
			die(json_encode(['status' => 'error', 'message' => "The admin password is not valid. The length must be between 8 and 30 characters and contain only english letters (A-Z), numbers (0-9), dot (.), plus (+), minus (-), underscore (_), number sign (#), exclamation mark (!) and question mark (?)."]));
		} else {
			die(json_encode(['status' => 'success']));
		}
	} elseif(isset($_POST['step']) && $_POST['step'] == 'install') {
		$dblink = @mysqli_connect($_POST['mysqlhost'], $_POST['mysqluser'], $_POST['mysqlpassword'], $_POST['mysqldatabase']);
		$errored = false;

		if(!$dblink) {
			$progress[] = ['type' => 'error', 'message' => 'Unable to connect to MySQL server! '.mysqli_connect_error()];
			exit;
		} else {
			$progress[] = ['type' => 'success', 'message' => 'Connection to the MySQL database successful'];
		}

		$table_list = getTableList($dblink);

		if($table_list === null) {
			$errored = true;
			$progress[] = ['type' => 'error', 'message' => 'Requesting table list '.mysqli_error($dblink)];
		} else {
			$progress[] = ['type' => 'success', 'message' => 'Requesting table list...'];

			$sqlRawData = getSQLFiles();
			$sqlRawDataCount = count($sqlRawData);
			$insertDataTotal = 0;
			$importedDataSuccess = 0;

			for($i = 0; $i < $sqlRawDataCount; $i++) {
				if(substr($sqlRawData[$i], 0, 12) == "INSERT INTO ") {
					++$insertDataTotal;
					$tbname = getTableName($sqlRawData[$i]);

					if(mysqli_query($dblink, $sqlRawData[$i])) {
						++$importedDataSuccess;
						//$progress[] = ['type' => 'success', 'message' => 'Content for table '.$tbname.' imported'];
					} else {
						$errored = true;
						$progress[] = ['type' => 'error', 'message' => 'Content for table '.$tbname.' not imported '.mysqli_error($dblink)];
					}
				} elseif(substr($sqlRawData[$i], 0, 13) == "CREATE TABLE ") {
					$tbname = getTableName($sqlRawData[$i]);

					if(is_array($table_list) && array_search($tbname, $table_list) !== false) {
						if(mysqli_query($dblink, "DROP TABLE ".$tbname)) {
							$progress[] = ['type' => 'success', 'message' => 'Deleted existing table '.$tbname];
						} else {
							$errored = true;
							$progress[] = ['type' => 'error', 'message' => 'Can not delete table '.$tbname.' '.mysqli_error($dblink)];
							break;
						}
					}

					if(mysqli_query($dblink, $sqlRawData[$i])) {
						$progress[] = ['type' => 'success', 'message' => 'Created table '.$tbname];
					} else {
						$errored = true;
						$progress[] = ['type' => 'error', 'message' => 'Can not create Table '.$tbname.' '.mysqli_error($dblink)];
					}
				}
			}

			if($insertDataTotal == $importedDataSuccess) {
				$progress[] = ['type' => 'info', 'message' => 'Imported '.$importedDataSuccess.' / '.$insertDataTotal.' Table contents'];
			} else {
				$progress[] = ['type' => 'error', 'message' => 'Imported '.$importedDataSuccess.' / '.$insertDataTotal.' Table contents'];
			}
		}

		if($_POST['tables'] == 'yes') {
			if(!$errored) {
				require_once("class/PWHash.php");
				$PWHash = new PWHash();
				$pwsalt = $PWHash->createSalt();

				if (mysqli_query($dblink, "INSERT INTO jts3servermodwebui_users (`name`, `password`, `salt`, `email`, `adminlevel`, `userstatus`, `registertime`) VALUES ('".mysqli_real_escape_string($dblink, $_POST['adminuser'])."', '".mysqli_real_escape_string($dblink, $PWHash->hashString($_POST['adminpassword'], $pwsalt))."', '".$pwsalt."', '".mysqli_real_escape_string($dblink, $_POST['adminemail'])."', '2', '0', '".time()."')")) {
					$progress[] = ['type' => 'success', 'message' => 'Creating Admin Account '.$_POST['adminuser']];
				} else {
					$progress[] = ['type' => 'error', 'message' => 'Creating Admin Account '.$_POST['adminuser'].' '.mysqli_error($dblink)];
					$errored = true;
				}
			}
		} else {
			$table_list = getTableList($dblink);

			if($table_list === null) {
				$errored = true;
				$progress[] = ['type' => 'error', 'message' => 'Requesting table list '.mysqli_error($dblink)];
			} elseif($table_list === false) {
			} else {
				$progress[] = ['type' => 'success', 'message' => 'Requesting table list...'];

				$sqlRawData = getSQLFiles();
				for($i = 0; $i < sizeof($sqlRawData); $i++) {
					if(substr($sqlRawData[$i], 0, 13) == "CREATE TABLE ") {
						$tableName = getTableName($sqlRawData[$i]);

						if (array_search($tableName, $table_list) !== false)
							$progress[] = ['type' => 'success', 'message' => 'Already exists '.$tableName];
					}
				}
			}
		}

		if(!$errored && $_POST['tables'] == "yes") {
			die(json_encode(['status' => 'success', 'step' => 'step5', 'tables' => 'yes', 'progress' => $progress]));
		} elseif(!$errored) {
			die(json_encode(['status' => 'success', 'step' => 'step5', 'tables' => 'no', 'progress' => $progress]));
		} else {
			die(json_encode(['status' => 'error', 'step' => 'step5', 'progress' => $progress]));
		}

		mysqli_close($dblink);
	} elseif(isset($_POST['step']) && $_POST['step'] == 'finish') {
		die(json_encode(['status' => 'success']));
	} elseif(isset($_POST['step']) && $_POST['step'] == 'welcome') {
		die(json_encode(['status' => 'success']));
	}

	if(isset($_POST['fetch_progress'])) {
		$tempprogress = $progress;
		$porgress = [];
		die(json_encode($tempprogress));
	}

	exit;
}

if (file_exists("config/dbconnect_config.php")) {
	$config = file("config/dbconnect_config.php", FILE_IGNORE_NEW_LINES);

	if (sizeof($config) == 6) {
		die("Configuration file already exists! Installation aborted. Use <a href=\"index.php\">index.php</a>.\n<br>\nKonfigurationsdatei existiert bereits! Installation abgebrochen. Benutze <a href=\"index.php\">index.php</a>.");
	}
}

$output = implode("", file("templates/index_install.tmpl"));
$tmpl = getFirstPage();

$output = str_replace('{content}', $tmpl, $output);
echo $output;

?>